import sys

def expand(cubes):
    expcubs = []
    for c in cubes:
        cub = (c[0], c[1])
        for i in range(c[2]):
            expcubs.append(cub)
    return expcubs

def doesfit(size, grid, x, y):
    for i in range(x, x+size[0]+1):
        for j in range(y, y+size[1]+1):
            try:
                if not grid[x][y] == 0:
                    return False
            except:
                return False
    return True

def patro(x, y, cubes):
    notset = False
    instructions = []
    floor = [[0 for j in range(y)] for i in range(x)]
    counter = 1
    used = set()
    i = 0
    while i < x:
        j = 0
        while j < y:
            found = False
            if not notset:
                ci = 0
            else:
                notset = False

            if floor[i][j] == 0:
                while ci < len(cubes):
                    c = cubes[ci]
                    if doesfit(c[1], floor, i, j) and not ci in used:
                        try:
                            floor[i+c[1][0]-1][j+c[1][1]-1]
                            
                            for k in range(i, i+c[1][0]):
                                for l in range(j, j+c[1][1]):
                                    floor[k][l] = counter
                            counter += 1
                            used.update([ci])
                            found = True
                            instructions.append((i,j,c[0],c[1], ci))
                            break
                        except:
                            pass
                    ci+=1
                
                if not found:
                    lastinst = instructions.pop()
                    used.discard(lastinst[4])
                    for k in range(lastinst[0], lastinst[0] + lastinst[3][0]):
                        for l in range(lastinst[1], lastinst[1] + lastinst[3][1]):
                            floor[k][l] = 0
                    i = lastinst[0]
                    j = lastinst[1]
                    notset = True
                    ci = lastinst[4]+1

            j+=1
        i+=1

    return (floor, instructions)



fr = open(sys.argv[1])
x, y, typ = fr.readline().split()
x, y = map(int, (x,y))
cubes = [line.rstrip().lower() for line in fr.readlines() ]
cubes = [c for c in cubes if c]
for c in range(len(cubes)):
    parsed = cubes[c].split()
    parsed[1] = parsed[1].split("x")
    parsed[1] = map(int, parsed[1])
    parsed[1].sort()
    parsed[1] = tuple(parsed[1])
    parsed[2] = int(parsed[2])
    parsed = tuple(parsed)
    cubes[c] = parsed

print x,y,typ

cubs = expand(cubes)
p = patro(x,y, cubs)
for ins in p[1]:
    print 1, ins[0]+1, ins[1]+1, ins[2], str(ins[3][0])+"x"+str(ins[3][1])

